SystemOrganization addCategory: #'Curium-Tests'!

TestCase subclass: #CMMakeV2dot6Test
	instanceVariableNames: 'cmake'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Curium-Tests'!

!CMMakeV2dot6Test commentStamp: '<historical>' prior: 0!
to test cmake 2.6

!

!CMMakeV2dot6Test class methodsFor: 'accessing' stamp: 'BernardoContreras 6/28/2012 13:04'!
packageNamesUnderTest
	^ #('Curium-Core')! !

!CMMakeV2dot6Test methodsFor: 'convenience' stamp: 'BernardoContreras 7/3/2012 20:57'!
assert: expected equalsContentsOf: aCMake
	| stream |
	stream := String new writeStream.
	aCMake writeOn: stream.
	self assert: expected contents equals: stream contents! !

!CMMakeV2dot6Test methodsFor: 'convenience' stamp: 'BernardoContreras 6/28/2012 12:36'!
commandNamed: name
	^ CMCommand named: name! !

!CMMakeV2dot6Test methodsFor: 'running' stamp: 'BernardoContreras 7/3/2012 20:57'!
setUp
	cmake := CMMakeGenerator v2dot6! !

!CMMakeV2dot6Test methodsFor: 'tests' stamp: 'BernardoContreras 7/3/2012 22:37'!
testAsString
	| expected |
	expected := String new writeStream.
	expected
		<< ('a ' , CMMakeV2dot6 asString , ' [');
		cr.
	expected
		<< 'cmake_minimum_required(VERSION 2.6)';
		crlf;
		nextPut: $].
	self assert: expected contents equals: cmake asString! !

!CMMakeV2dot6Test methodsFor: 'tests' stamp: 'BernardoContreras 7/7/2012 23:07'!
testCommandWithDoubleQuotedArgToString
	| cmd |
	cmd := self commandNamed: 'project'.
	cmd arg: 'Hello' dQuoted.
	self assert: 'project("Hello")' equals: cmd asString! !

!CMMakeV2dot6Test methodsFor: 'tests' stamp: 'BernardoContreras 7/3/2012 22:33'!
testWriteBasicConfigOnString
	| expected |
	expected := String new writeStream.
	expected
		<< 'cmake_minimum_required(VERSION 2.6)';
		crlf.
	self assert: expected equalsContentsOf: cmake! !

!CMMakeV2dot6Test methodsFor: 'tests' stamp: 'BernardoContreras 7/7/2012 23:08'!
testWriteConfigWithAnotherCommandOnString
	| expected |
	cmake addExecutable args: #('MyTestProject' 'main.c').
	expected := String new writeStream.
	expected
		<< 'cmake_minimum_required(VERSION 2.6)';
		crlf.
	expected
		<< 'add_executable(MyTestProject main.c)';
		crlf.
	self assert: expected equalsContentsOf: cmake! !

!CMMakeV2dot6Test methodsFor: 'tests' stamp: 'BernardoContreras 7/7/2012 23:08'!
testWriteConfigWithOneCommandOnString
	| expected |
	cmake project arg: 'MyTestProject'.
	expected := String new writeStream.
	expected
		<< 'cmake_minimum_required(VERSION 2.6)';
		crlf.
	expected
		<< 'project(MyTestProject)';
		crlf.
	self assert: expected equalsContentsOf: cmake! !
